diff --git a/menu/cbs/menu_cbs_ok.c b/menu/cbs/menu_cbs_ok.c
index 264f511c4ba..7ba3ce67d8c 100644
--- a/menu/cbs/menu_cbs_ok.c
+++ b/menu/cbs/menu_cbs_ok.c
@@ -3600,7 +3600,6 @@ static int action_ok_scan_directory_list(const char *path,
 static int action_ok_push_random_dir(const char *path,
       const char *label, unsigned type, size_t idx, size_t entry_idx)
 {
-   filebrowser_set_type(FILEBROWSER_SELECT_DIR);
    return generic_action_ok_displaylist_push(path, path,
          msg_hash_to_str(MENU_ENUM_LABEL_FAVORITES),
          type, idx,
diff --git a/menu/widgets/menu_filebrowser.c b/menu/widgets/menu_filebrowser.c
index 8fa819c6f2a..9966df0351b 100644
--- a/menu/widgets/menu_filebrowser.c
+++ b/menu/widgets/menu_filebrowser.c
@@ -49,7 +49,8 @@ void filebrowser_clear_type(void)
 
 void filebrowser_set_type(enum filebrowser_enums type)
 {
-   filebrowser_types = type;
+   if (filebrowser_types != FILEBROWSER_SELECT_FILE)
+      filebrowser_types = type;
 }
 
 void filebrowser_parse(void *data, unsigned type_data)
